/*******************************************************************************
* File Name: LCD_nCS.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_LCD_nCS_H) /* Pins LCD_nCS_H */
#define CY_PINS_LCD_nCS_H

#include "cytypes.h"
#include "cyfitter.h"
#include "LCD_nCS_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    LCD_nCS_Write(uint8 value) ;
void    LCD_nCS_SetDriveMode(uint8 mode) ;
uint8   LCD_nCS_ReadDataReg(void) ;
uint8   LCD_nCS_Read(void) ;
uint8   LCD_nCS_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define LCD_nCS_DRIVE_MODE_BITS        (3)
#define LCD_nCS_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - LCD_nCS_DRIVE_MODE_BITS))

#define LCD_nCS_DM_ALG_HIZ         (0x00u)
#define LCD_nCS_DM_DIG_HIZ         (0x01u)
#define LCD_nCS_DM_RES_UP          (0x02u)
#define LCD_nCS_DM_RES_DWN         (0x03u)
#define LCD_nCS_DM_OD_LO           (0x04u)
#define LCD_nCS_DM_OD_HI           (0x05u)
#define LCD_nCS_DM_STRONG          (0x06u)
#define LCD_nCS_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define LCD_nCS_MASK               LCD_nCS__MASK
#define LCD_nCS_SHIFT              LCD_nCS__SHIFT
#define LCD_nCS_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define LCD_nCS_PS                     (* (reg32 *) LCD_nCS__PS)
/* Port Configuration */
#define LCD_nCS_PC                     (* (reg32 *) LCD_nCS__PC)
/* Data Register */
#define LCD_nCS_DR                     (* (reg32 *) LCD_nCS__DR)
/* Input Buffer Disable Override */
#define LCD_nCS_INP_DIS                (* (reg32 *) LCD_nCS__PC2)


#if defined(LCD_nCS__INTSTAT)  /* Interrupt Registers */

    #define LCD_nCS_INTSTAT                (* (reg32 *) LCD_nCS__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define LCD_nCS_DRIVE_MODE_SHIFT       (0x00u)
#define LCD_nCS_DRIVE_MODE_MASK        (0x07u << LCD_nCS_DRIVE_MODE_SHIFT)


#endif /* End Pins LCD_nCS_H */


/* [] END OF FILE */
