/*******************************************************************************
* File Name: LCD_nWR.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_LCD_nWR_H) /* Pins LCD_nWR_H */
#define CY_PINS_LCD_nWR_H

#include "cytypes.h"
#include "cyfitter.h"
#include "LCD_nWR_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    LCD_nWR_Write(uint8 value) ;
void    LCD_nWR_SetDriveMode(uint8 mode) ;
uint8   LCD_nWR_ReadDataReg(void) ;
uint8   LCD_nWR_Read(void) ;
uint8   LCD_nWR_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define LCD_nWR_DRIVE_MODE_BITS        (3)
#define LCD_nWR_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - LCD_nWR_DRIVE_MODE_BITS))

#define LCD_nWR_DM_ALG_HIZ         (0x00u)
#define LCD_nWR_DM_DIG_HIZ         (0x01u)
#define LCD_nWR_DM_RES_UP          (0x02u)
#define LCD_nWR_DM_RES_DWN         (0x03u)
#define LCD_nWR_DM_OD_LO           (0x04u)
#define LCD_nWR_DM_OD_HI           (0x05u)
#define LCD_nWR_DM_STRONG          (0x06u)
#define LCD_nWR_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define LCD_nWR_MASK               LCD_nWR__MASK
#define LCD_nWR_SHIFT              LCD_nWR__SHIFT
#define LCD_nWR_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define LCD_nWR_PS                     (* (reg32 *) LCD_nWR__PS)
/* Port Configuration */
#define LCD_nWR_PC                     (* (reg32 *) LCD_nWR__PC)
/* Data Register */
#define LCD_nWR_DR                     (* (reg32 *) LCD_nWR__DR)
/* Input Buffer Disable Override */
#define LCD_nWR_INP_DIS                (* (reg32 *) LCD_nWR__PC2)


#if defined(LCD_nWR__INTSTAT)  /* Interrupt Registers */

    #define LCD_nWR_INTSTAT                (* (reg32 *) LCD_nWR__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define LCD_nWR_DRIVE_MODE_SHIFT       (0x00u)
#define LCD_nWR_DRIVE_MODE_MASK        (0x07u << LCD_nWR_DRIVE_MODE_SHIFT)


#endif /* End Pins LCD_nWR_H */


/* [] END OF FILE */
